> ## Documentation Index
> Fetch the complete documentation index at: https://www.courier.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Replace a journey-scoped notification template

> PUT /journeys/{templateId}/templates/{notificationId} replaces the draft content of a journey-scoped notification template.



## OpenAPI

````yaml /openapi-specs/openapi.documented.yml put /journeys/{templateId}/templates/{notificationId}
openapi: 3.0.1
info:
  title: Courier
  description: The Courier REST API for sending and managing notifications across channels.
  version: 0.0.1
servers:
  - url: https://api.courier.com
    description: Production
security: []
paths:
  /journeys/{templateId}/templates/{notificationId}:
    put:
      tags:
        - Journeys
      summary: Replace a journey-scoped notification template
      description: >-
        PUT /journeys/{templateId}/templates/{notificationId} replaces the draft
        content of a journey-scoped notification template.
      operationId: journeys_replaceTemplate
      parameters:
        - in: path
          name: templateId
          schema:
            type: string
            minLength: 1
          required: true
          description: Journey id
        - in: path
          name: notificationId
          schema:
            type: string
            minLength: 1
          required: true
          description: Notification template id
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/JourneyTemplateReplaceRequest'
            examples:
              Example1:
                summary: Replace draft
                value:
                  name: Welcome email v2
                  tags: []
                  brand: null
                  subscription: null
                  content:
                    version: '2022-01-01'
                    elements: []
      responses:
        '200':
          description: Updated notification template
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/JourneyTemplateGetResponse'
              examples:
                Example1:
                  summary: Updated notification template
                  value:
                    name: Welcome email v2
                    tags: []
                    brand: null
                    subscription: null
                    content:
                      scope: default
                      version: '2022-01-01'
                      elements: []
        '400':
          description: Bad request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/BadRequest'
              examples:
                Example:
                  value:
                    message: Example message text
                    type: invalid_request_error
        '404':
          description: Not found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/NotFound'
              examples:
                Example:
                  value:
                    message: Example message text
                    type: invalid_request_error
        '422':
          description: Unprocessable entity
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/UnprocessableEntity'
              examples:
                Example:
                  value:
                    message: Example message text
                    type: invalid_request_error
      security:
        - BearerAuth: []
      x-codeSamples:
        - lang: JavaScript
          source: >-
            import Courier from '@trycourier/courier';


            const client = new Courier({
              apiKey: process.env['COURIER_API_KEY'], // This is the default and can be omitted
            });


            const journeyTemplateGetResponse = await
            client.journeys.templates.replace('x', {
              templateId: 'x',
              notification: {
                brand: { id: 'id' },
                content: { elements: [{}], version: '2022-01-01' },
                name: 'name',
                subscription: { topic_id: 'topic_id' },
                tags: ['string'],
              },
            });


            console.log(journeyTemplateGetResponse.id);
        - lang: Python
          source: |-
            import os
            from courier import Courier

            client = Courier(
                api_key=os.environ.get("COURIER_API_KEY"),  # This is the default and can be omitted
            )
            journey_template_get_response = client.journeys.templates.replace(
                notification_id="x",
                template_id="x",
                notification={
                    "brand": {
                        "id": "id"
                    },
                    "content": {
                        "elements": [{}],
                        "version": "2022-01-01",
                    },
                    "name": "name",
                    "subscription": {
                        "topic_id": "topic_id"
                    },
                    "tags": ["string"],
                },
            )
            print(journey_template_get_response.id)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/trycourier/courier-go\"\n\t\"github.com/trycourier/courier-go/option\"\n\t\"github.com/trycourier/courier-go/shared\"\n)\n\nfunc main() {\n\tclient := courier.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\tjourneyTemplateGetResponse, err := client.Journeys.Templates.Replace(\n\t\tcontext.TODO(),\n\t\t\"x\",\n\t\tcourier.JourneyTemplateReplaceParams{\n\t\t\tTemplateID: \"x\",\n\t\t\tJourneyTemplateReplaceRequest: courier.JourneyTemplateReplaceRequestParam{\n\t\t\t\tNotification: courier.JourneyTemplateReplaceRequestNotificationParam{\n\t\t\t\t\tBrand: courier.JourneyTemplateReplaceRequestNotificationBrandParam{\n\t\t\t\t\t\tID: \"id\",\n\t\t\t\t\t},\n\t\t\t\t\tContent: courier.JourneyTemplateReplaceRequestNotificationContentParam{\n\t\t\t\t\t\tElements: []shared.ElementalNodeUnionParam{{\n\t\t\t\t\t\t\tOfElementalTextNodeWithType: &shared.ElementalTextNodeWithTypeParam{\n\t\t\t\t\t\t\t\tElementalBaseNodeParam: shared.ElementalBaseNodeParam{},\n\t\t\t\t\t\t\t},\n\t\t\t\t\t\t}},\n\t\t\t\t\t\tVersion: \"2022-01-01\",\n\t\t\t\t\t},\n\t\t\t\t\tName: \"name\",\n\t\t\t\t\tSubscription: courier.JourneyTemplateReplaceRequestNotificationSubscriptionParam{\n\t\t\t\t\t\tTopicID: \"topic_id\",\n\t\t\t\t\t},\n\t\t\t\t\tTags: []string{\"string\"},\n\t\t\t\t},\n\t\t\t},\n\t\t},\n\t)\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", journeyTemplateGetResponse.ID)\n}\n"
        - lang: Java
          source: |-
            package com.courier.example;

            import com.courier.client.CourierClient;
            import com.courier.client.okhttp.CourierOkHttpClient;
            import com.courier.models.ElementalTextNodeWithType;
            import com.courier.models.journeys.JourneyTemplateGetResponse;
            import com.courier.models.journeys.JourneyTemplateReplaceRequest;
            import com.courier.models.journeys.templates.TemplateReplaceParams;

            public final class Main {
                private Main() {}

                public static void main(String[] args) {
                    CourierClient client = CourierOkHttpClient.fromEnv();

                    TemplateReplaceParams params = TemplateReplaceParams.builder()
                        .templateId("x")
                        .notificationId("x")
                        .journeyTemplateReplaceRequest(JourneyTemplateReplaceRequest.builder()
                            .notification(JourneyTemplateReplaceRequest.Notification.builder()
                                .brand(JourneyTemplateReplaceRequest.Notification.Brand.builder()
                                    .id("id")
                                    .build())
                                .content(JourneyTemplateReplaceRequest.Notification.Content.builder()
                                    .addElement(ElementalTextNodeWithType.builder().build())
                                    .version(JourneyTemplateReplaceRequest.Notification.Content.Version._2022_01_01)
                                    .build())
                                .name("name")
                                .subscription(JourneyTemplateReplaceRequest.Notification.Subscription.builder()
                                    .topicId("topic_id")
                                    .build())
                                .addTag("string")
                                .build())
                            .build())
                        .build();
                    JourneyTemplateGetResponse journeyTemplateGetResponse = client.journeys().templates().replace(params);
                }
            }
        - lang: Ruby
          source: |-
            require "courier"

            courier = Courier::Client.new(api_key: "My API Key")

            journey_template_get_response = courier.journeys.templates.replace(
              "x",
              template_id: "x",
              notification: {
                brand: {id: "id"},
                content: {elements: [{}], version: :"2022-01-01"},
                name: "name",
                subscription: {topic_id: "topic_id"},
                tags: ["string"]
              }
            )

            puts(journey_template_get_response)
        - lang: PHP
          source: >-
            <?php


            require_once dirname(__DIR__) . '/vendor/autoload.php';


            use Courier\Client;

            use Courier\Core\Exceptions\APIException;


            $client = new Client(apiKey: getenv('COURIER_API_KEY') ?: 'My API
            Key');


            try {
              $journeyTemplateGetResponse = $client->journeys->templates->replace(
                'x',
                templateID: 'x',
                notification: [
                  'brand' => ['id' => 'id'],
                  'content' => [
                    'elements' => [
                      [
                        'channels' => ['string'],
                        'if' => 'if',
                        'loop' => 'loop',
                        'ref' => 'ref',
                        'type' => 'text',
                      ],
                    ],
                    'version' => '2022-01-01',
                    'scope' => 'default',
                  ],
                  'name' => 'name',
                  'subscription' => ['topicID' => 'topic_id'],
                  'tags' => ['string'],
                ],
                state: 'state',
              );

              var_dump($journeyTemplateGetResponse);
            } catch (APIException $e) {
              echo $e->getMessage();
            }
        - lang: C#
          source: >-
            using System;

            using TryCourier;

            using TryCourier.Models;

            using TryCourier.Models.Journeys.Templates;


            CourierClient client = new();


            TemplateReplaceParams parameters = new()

            {
                TemplateID = "x",
                NotificationID = "x",
                Notification = new()
                {
                    Brand = new("id"),
                    Content = new()
                    {
                        Elements =
                        [
                            new ElementalTextNodeWithType()
                            {
                                Channels =
                                [
                                    "string"
                                ],
                                If = "if",
                                Loop = "loop",
                                Ref = "ref",
                                Type = ElementalTextNodeWithTypeIntersectionMember1Type.Text,
                            },
                        ],
                        Version = TemplateReplaceParamsNotificationContentVersion.V2022_01_01,
                        Scope = TemplateReplaceParamsNotificationContentScope.Default,
                    },
                    Name = "name",
                    Subscription = new("topic_id"),
                    Tags =
                    [
                        "string"
                    ],
                },
            };


            var journeyTemplateGetResponse = await
            client.Journeys.Templates.Replace(parameters);


            Console.WriteLine(journeyTemplateGetResponse);
        - lang: CLI
          source: |-
            courier journeys:templates replace \
              --api-key 'My API Key' \
              --template-id x \
              --notification-id x \
              --notification "{brand: {id: id}, content: {elements: [{}], version: '2022-01-01'}, name: name, subscription: {topic_id: topic_id}, tags: [string]}"
components:
  schemas:
    JourneyTemplateReplaceRequest:
      description: Request body for replacing a journey-scoped notification template draft.
      type: object
      properties:
        notification:
          type: object
          properties:
            name:
              type: string
            tags:
              type: array
              items:
                type: string
            brand:
              nullable: true
              type: object
              properties:
                id:
                  type: string
              required:
                - id
            subscription:
              nullable: true
              type: object
              properties:
                topic_id:
                  type: string
              required:
                - topic_id
            content:
              type: object
              properties:
                elements:
                  type: array
                  items:
                    $ref: '#/components/schemas/ElementalNode'
                scope:
                  type: string
                  enum:
                    - default
                    - strict
                version:
                  type: string
                  enum:
                    - '2022-01-01'
              required:
                - elements
                - version
          required:
            - name
            - tags
            - brand
            - subscription
            - content
        state:
          type: string
      required:
        - notification
    JourneyTemplateGetResponse:
      description: A journey-scoped notification template.
      type: object
      properties:
        name:
          type: string
        tags:
          type: array
          items:
            type: string
        brand:
          nullable: true
          type: object
          properties:
            id:
              type: string
          required:
            - id
        subscription:
          nullable: true
          type: object
          properties:
            topic_id:
              type: string
          required:
            - topic_id
        content:
          type: object
          properties:
            elements:
              type: array
              items:
                $ref: '#/components/schemas/ElementalNode'
            scope:
              type: string
              enum:
                - default
                - strict
            version:
              type: string
              enum:
                - '2022-01-01'
          required:
            - elements
            - version
        id:
          type: string
        state:
          default: DRAFT
          type: string
          enum:
            - DRAFT
            - PUBLISHED
        created:
          type: integer
          format: int64
        creator:
          type: string
        updated:
          type: integer
          format: int64
        updater:
          type: string
      required:
        - name
        - tags
        - brand
        - subscription
        - content
        - id
        - state
        - created
        - creator
    BadRequest:
      title: BadRequest
      type: object
      properties:
        type:
          type: string
          enum:
            - invalid_request_error
      required:
        - type
      allOf:
        - $ref: '#/components/schemas/BaseError'
    NotFound:
      title: NotFound
      type: object
      properties:
        type:
          type: string
          enum:
            - invalid_request_error
      required:
        - type
      allOf:
        - $ref: '#/components/schemas/BaseError'
    UnprocessableEntity:
      title: UnprocessableEntity
      type: object
      properties:
        type:
          type: string
          enum:
            - invalid_request_error
      required:
        - type
      allOf:
        - $ref: '#/components/schemas/BaseError'
    ElementalNode:
      title: ElementalNode
      oneOf:
        - type: object
          allOf:
            - type: object
              properties:
                type:
                  type: string
                  enum:
                    - text
            - $ref: '#/components/schemas/ElementalTextNode'
          required:
            - type
        - type: object
          allOf:
            - type: object
              properties:
                type:
                  type: string
                  enum:
                    - meta
            - $ref: '#/components/schemas/ElementalMetaNode'
          required:
            - type
        - type: object
          allOf:
            - type: object
              properties:
                type:
                  type: string
                  enum:
                    - channel
            - $ref: '#/components/schemas/ElementalChannelNode'
          required:
            - type
            - channel
        - type: object
          allOf:
            - type: object
              properties:
                type:
                  type: string
                  enum:
                    - image
            - $ref: '#/components/schemas/ElementalImageNode'
          required:
            - type
        - type: object
          allOf:
            - type: object
              properties:
                type:
                  type: string
                  enum:
                    - action
            - $ref: '#/components/schemas/ElementalActionNode'
          required:
            - type
        - type: object
          allOf:
            - type: object
              properties:
                type:
                  type: string
                  enum:
                    - divider
            - $ref: '#/components/schemas/ElementalDividerNode'
          required:
            - type
        - type: object
          allOf:
            - type: object
              properties:
                type:
                  type: string
                  enum:
                    - quote
            - $ref: '#/components/schemas/ElementalQuoteNode'
          required:
            - type
        - type: object
          allOf:
            - type: object
              properties:
                type:
                  type: string
                  enum:
                    - html
            - $ref: '#/components/schemas/ElementalHtmlNode'
          required:
            - type
    BaseError:
      title: BaseError
      type: object
      properties:
        message:
          type: string
          description: A message describing the error that occurred.
      required:
        - message
    ElementalTextNode:
      title: ElementalTextNode
      type: object
      description: Represents a body of text to be rendered inside of the notification.
      properties:
        content:
          type: string
          description: |-
            The text content displayed in the notification. Either this
            field must be specified, or the elements field
        align:
          $ref: '#/components/schemas/TextAlign'
          description: Text alignment.
        text_style:
          $ref: '#/components/schemas/TextStyle'
          nullable: true
          description: Allows the text to be rendered as a heading level.
        color:
          type: string
          nullable: true
          description: Specifies the color of text. Can be any valid css color value
        bold:
          type: string
          nullable: true
          description: Apply bold to the text
        italic:
          type: string
          nullable: true
          description: Apply italics to the text
        strikethrough:
          type: string
          nullable: true
          description: Apply a strike through the text
        underline:
          type: string
          nullable: true
          description: Apply an underline to the text
        locales:
          $ref: '#/components/schemas/Locales'
          nullable: true
          description: >-
            Region specific content. See [locales
            docs](https://www.courier.com/docs/platform/content/elemental/locales/)
            for more details.
        format:
          type: string
          enum:
            - markdown
          nullable: true
      required:
        - content
        - align
      allOf:
        - $ref: '#/components/schemas/ElementalBaseNode'
    ElementalMetaNode:
      title: ElementalMetaNode
      type: object
      description: >-
        The meta element contains information describing the notification that
        may 

        be used by a particular channel or provider. One important field is the
        title 

        field which will be used as the title for channels that support it.
      properties:
        title:
          type: string
          nullable: true
          description: >-
            The title to be displayed by supported channels. For example, the
            email subject.
      allOf:
        - $ref: '#/components/schemas/ElementalBaseNode'
    ElementalChannelNode:
      title: ElementalChannelNode
      type: object
      description: >-
        The channel element allows a notification to be customized based on
        which channel it is sent through. 

        For example, you may want to display a detailed message when the
        notification is sent through email, 

        and a more concise message in a push notification. Channel elements are
        only valid as top-level 

        elements; you cannot nest channel elements. If there is a channel
        element specified at the top-level 

        of the document, all sibling elements must be channel elements.

        Note: As an alternative, most elements support a `channel` property.
        Which allows you to selectively 

        display an individual element on a per channel basis. See the 

        [control flow
        docs](https://www.courier.com/docs/platform/content/elemental/control-flow/)
        for more details.
      properties:
        channel:
          type: string
          example: email
          description: >-
            The channel the contents of this element should be applied to. Can
            be `email`,

            `push`, `direct_message`, `sms` or a provider such as slack
        raw:
          type: object
          additionalProperties: true
          nullable: true
          description: >-
            Raw data to apply to the channel. If `elements` has not been
            specified, `raw` is required.
      allOf:
        - $ref: '#/components/schemas/ElementalBaseNode'
    ElementalImageNode:
      title: ElementalImageNode
      type: object
      description: Used to embed an image into the notification.
      properties:
        src:
          type: string
          description: The source of the image.
        href:
          type: string
          nullable: true
          description: A URL to link to when the image is clicked.
        align:
          $ref: '#/components/schemas/IAlignment'
          nullable: true
          description: The alignment of the image.
        altText:
          type: string
          nullable: true
          description: Alternate text for the image.
        width:
          type: string
          nullable: true
          description: CSS width properties to apply to the image. For example, 50px
      required:
        - src
      allOf:
        - $ref: '#/components/schemas/ElementalBaseNode'
    ElementalActionNode:
      title: ElementalActionNode
      type: object
      description: Allows the user to execute an action. Can be a button or a link.
      properties:
        content:
          type: string
          description: The text content of the action shown to the user.
        href:
          type: string
          description: The target URL of the action.
        action_id:
          type: string
          nullable: true
          description: A unique id used to identify the action when it is executed.
        align:
          nullable: true
          description: The alignment of the action button. Defaults to "center".
          allOf:
            - $ref: '#/components/schemas/IAlignment'
        background_color:
          type: string
          nullable: true
          description: The background color of the action button.
        style:
          nullable: true
          description: Defaults to `button`.
          allOf:
            - $ref: '#/components/schemas/IActionButtonStyle'
        locales:
          description: >-
            Region specific content. See [locales
            docs](https://www.courier.com/docs/platform/content/elemental/locales/)
            for more details.
          allOf:
            - $ref: '#/components/schemas/Locales'
      required:
        - content
        - href
        - locales
      allOf:
        - $ref: '#/components/schemas/ElementalBaseNode'
    ElementalDividerNode:
      title: ElementalDividerNode
      type: object
      description: Renders a dividing line between elements.
      properties:
        color:
          type: string
          nullable: true
          description: The CSS color to render the line with. For example, `#fff`
      allOf:
        - $ref: '#/components/schemas/ElementalBaseNode'
    ElementalQuoteNode:
      title: ElementalQuoteNode
      type: object
      description: Renders a quote block.
      properties:
        content:
          type: string
          description: The text value of the quote.
        align:
          $ref: '#/components/schemas/IAlignment'
          nullable: true
          description: Alignment of the quote.
        borderColor:
          type: string
          nullable: true
          description: CSS border color property. For example, `#fff`
        text_style:
          $ref: '#/components/schemas/TextStyle'
        locales:
          $ref: '#/components/schemas/Locales'
          description: >-
            Region specific content. See [locales
            docs](https://www.courier.com/docs/platform/content/elemental/locales/)
            for more details.
      required:
        - content
        - text_style
        - locales
      allOf:
        - $ref: '#/components/schemas/ElementalBaseNode'
    ElementalHtmlNode:
      title: ElementalHtmlNode
      type: object
      description: >-
        Raw HTML string inside an Elemental document. When rendering a message,
        this node is turned into output only for the email channel; for other
        channels it produces no blocks.
      properties:
        content:
          type: string
          description: Raw HTML string to render inside the notification.
        locales:
          $ref: '#/components/schemas/Locales'
          nullable: true
          description: >-
            Region-specific `content` overrides. See [locales
            docs](https://www.courier.com/docs/platform/content/elemental/locales/)
            for more details.
      required:
        - content
      allOf:
        - $ref: '#/components/schemas/ElementalBaseNode'
    TextAlign:
      title: TextAlign
      type: string
      enum:
        - left
        - center
        - right
    TextStyle:
      title: TextStyle
      type: string
      enum:
        - text
        - h1
        - h2
        - subtext
    Locales:
      title: Locales
      type: object
      additionalProperties:
        $ref: '#/components/schemas/Locale'
      nullable: true
    ElementalBaseNode:
      title: ElementalBaseNode
      type: object
      properties:
        channels:
          type: array
          items:
            type: string
          nullable: true
        ref:
          type: string
          nullable: true
        if:
          type: string
          nullable: true
        loop:
          type: string
          nullable: true
    IAlignment:
      title: IAlignment
      type: string
      enum:
        - center
        - left
        - right
        - full
    IActionButtonStyle:
      title: IActionButtonStyle
      type: string
      enum:
        - button
        - link
    Locale:
      title: Locale
      type: object
      properties:
        content:
          type: string
      required:
        - content
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer

````